import java.util.*;
import java.io.*;

/** Builds a FA transition table at runtime
 * @author David Wagstaff
 */
public class Fa5 {

  public static void main(String[] args) {
      if (args.length < 2) {
         System.out.println("Incomplete argument list\n");
         System.exit(1);
      }
      try {
            System.out.println(recognize(args[1], args[2]));
      }
      catch (Exception e) {
            System.out.println(e);
      }
  }

   public static boolean recognize(String file, String str) throws Exception {
      Properties transitions = new Properties();
      transitions.load(new FileInputStream(file));

      //Test
      //Note: Hashtable using a 2-tuple key is simulating a two-dimensional array
      String state = "start";
      for (int i=0; i<str.length(); i++) {
         state = (String)transitions.get(state + "," + str.charAt(i));
      }
      String finalStates = (String)transitions.get("finalStates");
      return finalStates.indexOf(state) != -1;
   }

}